-- refactoring commands added to pfe command interpreter
-- this file is generated from GenEditorInterfaces.hs
-- by calling the executable as follows:
--   editors/GenEditorInterfaces pfeRefactoringCmds > refactorer/PfeRefactoringCmds.hs

module PfeRefactoringCmds where

import CmdLineParser 
import RefacMoveDef
import RefacRenaming
import RefacDupDef
import RefacNewDef
import RefacRmDef
import RefacAddRmParam
import RefacGenDef
import RefacMvDefBtwMod
import RefacCleanImps
import RefacADT
-- import RefacSwapArgs
-- import RefacCase


pfeRefactoringCmds =
  [
   -- menu Names/Scopes
   ("rename",(Args " <fileName> <name (New name? )> <line> <column>" rename, " Rename a variable name"))
  ,("liftToTopLevel",(Args " <fileName> <line> <column>" liftToTopLevel, " Lift a local declaration to top level"))
  ,("liftOneLevel",(Args " <fileName> <line> <column>" liftOneLevel, " Lift a local declaration one level up"))
  ,("demote",(Args " <fileName> <line> <column>" demote, " Demote a declaration to where it is used"))
   -- menu Definitions
  ,("introNewDef",(Args " <fileName> <name (Name for new definition? )> <line> <column> <line> <column>" introNewDef, " Introduce a new definition"))
  ,("unfoldDef",(Args " <fileName> <line> <column>" unfoldDef, " unfold a definition"))
  ,("generaliseDef",(Args " <fileName> <name (name of new parameter? )> <line> <column> <line> <column>" generaliseDef, " generalise a definition"))
  ,("removeDef",(Args " <fileName> <line> <column>" removeDef, " Remove a definition if it is no used"))
  ,("duplicateDef",(Args " <fileName> <name (Name for duplicate? )> <line> <column>" duplicateDef, " Duplicate a definition at the same level"))
  ,("addOneParameter",(Args " <fileName> <name (name of new parameter? )> <line> <column>" addOneParameter, " add parameter (default undefined)"))
  ,("rmOneParameter",(Args " <fileName> <line> <column>" rmOneParameter, " remove unused parameter"))
  ,("moveDefBtwMod",(Args " <fileName> <name (name of the destination module? )> <line> <column>" moveDefBtwMod, " move a definition from one module to another module"))
   -- menu Import/Export
  ,("cleanImports",(Args " <fileName>" cleanImports, " tidy up the import list of the current module"))
  ,("mkImpExplicit",(Args " <fileName> <line> <column>" mkImpExplicit, " make the used entities explicit"))
  ,("addToExport",(Args " <fileName> <line> <column>" addToExport, " add an identifier to the export list"))
  ,("rmFromExport",(Args " <fileName> <line> <column>" rmFromExport, " remove an identifier from the export list"))
   -- menu Data types
  ,("addFieldLabels",(Args " <fileName> <line> <column>" addFieldLabels, " add field labels to a data type declaration"))
  ,("addDiscriminators",(Args " <fileName> <line> <column>" addDiscriminators, " add discriminator functions to a data type declaration"))
  ,("addConstructors",(Args " <fileName> <line> <column>" addConstructors, " add constructor functions to a data type declaration"))
  ,("elimNestedPatterns",(Args " <fileName> <line> <column>" elimNestedPatterns, " eliminate pattern matchings"))
  ,("elimPatterns",(Args " <fileName> <line> <column>" elimPatterns, " eliminate pattern matchings"))
  ,("createADTMod",(Args " <fileName> <line> <column>" createADTMod, " create an new ADT module"))
  ,("fromAlgebraicToADT",(Args " <fileName> <line> <column>" fromAlgebraicToADT, " Transform an algebraic data type to an ADT"))
  ]
