
module RefacSwapArgs(swapArgs) where

import RefacUtils

swapArgs args  
 = do let fileName = ghead "filename" args       
          row      = read (args!!1)::Int        
          col      = read (args!!2)::Int        
      modInfo@(_,exps, mod, _)<-parseSourceFile fileName  
      let pnt =locToPNT fileName (row, col) mod                                 
      if isFunPNT pnt mod   
       then do r<-applyRefac (doSwap pnt) (Just modInfo) fileName
               if isExported pnt exps
                then  do rs <- applyRefacToClientMods (doSwap pnt) fileName
                         writeRefactoredFiles False (r:rs)      
                else  writeRefactoredFiles False [r]
       else error "\nInvalid cursor position!"  



doSwap pnt (_, _, mod) = (applyTP (full_buTP (idTP `adhocTP`  inMatch 
                                                       `adhocTP`  inExp
                                                       `adhocTP`  inDecl))) mod 
  where 
    inMatch ((HsMatch loc fun pats rhs ds)::HsMatchP)
      | fun == pnt   
      = case pats of    
         (p1:p2:ps) -> do  pats'<-swap p1 p2 pats  
                           return (HsMatch loc fun pats' rhs ds)
         _          -> error "Insufficient arguments to swap." 
    inMatch m = return m  

    inExp exp@((Exp (HsApp (Exp (HsApp e e1)) e2))::HsExpP)
      | expToPNT e == pnt     
      = swap e1 e2 exp     
    inExp e = return e 
 
    inDecl (decl@(Dec (HsTypeSig loc is c tp))::HsDeclP)
      |isTypeSigOf pnt decl 
      = if length is ==1 
         then do let ts = tyFunToList tp 
                 swap (ts!!0) (ts!!1) decl
         else error "This type signature defines the type of more than one identifiers."
    inDecl d = return d 

    tyFunToList (Typ (HsTyFun t1 t2)) = t1:(tyFunToList t2)
    tyFunToList t = [t]
 
