module DerivingRead where
import DerivingUtils

deriveRead src t@(_,TypeInfo{constructors=cs}) =
    return [fun src [alt (choice (map rdCon cs))]]
  where
    d = var (localVal "d")

    alt = alt1 src readsPrec d

    rdCon ConInfo{conName=c0,conArity=n} =
      case n of
	0 -> rdConName cn c
	_ -> rdParenArg (comp (rdConName cn c:replicate n rdArg))
      where
        c = convCon t c0
	cn = getBaseName c0
	
    rdConName cn c = rdToken (con c) (str cn)
    rdToken = opapp (HsVar readToken)
    rdParenArg a = opapp (HsVar readParenArg) d a
    rdArg = var readArgument

    comp = foldl1 (opapp (HsVar readAp))
    choice = foldr1 (opapp readChoice)

    readParenArg = pt "readParenArg"
    readArgument = pt "readArgument"
    readToken = pt "readToken"
    readsPrec = pt "readsPrec"
    readAp = pt "readAp"
    readChoice = HsVar (pt "readChoice")

    pt = topVal mod_PreludeText
